'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var User = require('./user');
var Photo = require('./photo');

var Status = function () {
  function Status(status) {
    _classCallCheck(this, Status);

    this.created_at = status.created_at;
    this.id = status.id;
    this.rawid = status.rawid;
    this.text = status.text;
    this.source = status.source;
    this.truncated = status.truncated;
    this.in_reply_to_status_id = status.in_reply_to_status_id;
    this.in_reply_to_user_id = status.in_reply_to_user_id;
    this.favorited = status.favorited;
    this.in_reply_to_screen_name = status.in_reply_to_screen_name;
    this.is_self = status.is_self;
    this.location = status.location;
    if (status.hasOwnProperty('repost_status_id')) {
      this.repost_status_id = status.repost_status_id;
    }
    if (status.hasOwnProperty('repost_user_id')) {
      this.repost_user_id = status.repost_user_id;
    }
    if (status.hasOwnProperty('repost_screen_name')) {
      this.repost_screen_name = status.repost_screen_name;
    }
    if (status.hasOwnProperty('repost_status')) {
      this.repost_status = new Status(status.repost_status);
    }
    this.user = new User(status.user);
    if (status.hasOwnProperty('photo')) {
      this.photo = new Photo(status.photo);
    }
    this.type = this.getType();
  }

  _createClass(Status, [{
    key: 'isReply',
    value: function isReply() {
      return this.in_reply_to_status_id !== '' || this.in_reply_to_user_id !== '';
    }
  }, {
    key: 'isRepost',
    value: function isRepost() {
      return this.hasOwnProperty('repost_status_id') && this.repost_status_id !== '';
    }
  }, {
    key: 'isOrigin',
    value: function isOrigin() {
      return !(this.isReply() || this.isRepost());
    }
  }, {
    key: 'isOriginRepost',
    value: function isOriginRepost() {
      return this.isOrigin() && this.text.match(/转@/g);
    }
  }, {
    key: 'getType',
    value: function getType() {
      if (this.isReply()) return 'reply';
      if (this.isRepost()) return 'repost';
      if (this.isOrigin()) return 'origin';
      return 'unknown';
    }
  }]);

  return Status;
}();

module.exports = Status;